Subject: RE: [External] : bug#36745: 27.0.50; completing-read with require-match nil does not accept spaces

From: Drew Adams <[email-masked]>
Date: Sun, 20 Feb 2022 22:24:43 +0000

> > Anyway, my opinion doesn't matter much.  I don't like the behavior of
> > space not just inserting a space - I get angry every time this happens.
> > I wonder what others do think about it.
> 
> I absolutely loathe it, so I have:
> 
> (keymap-set minibuffer-local-completion-map "SPC" #'self-insert-command)
> (keymap-set minibuffer-local-completion-map "?" #'self-insert-command)
> 
> But I don't think this is something we can change at this point.

Why not?  You seem to change lots of things "at
this point", whatever the point.

I requested this changed decades ago.  And I may
have filed it as an enhancement-request bug.

It took years for SPC to become self-inserting
for (only) file-name completion.  Many more
years have passed since then.  Courage!

> But I've now added this to the Minibuffer Edit node in the Emacs manual.

What did you add?  Telling users that if they
want sane behavior they can add such bindings
themselves?  Did you tell them Emacs still
doesn't dare do that by default?

How about proposing it in emacs-devel, or
taking a user poll, to see how many users
really don't want such keys to self-insert?

> I don't think there's anything more to do in this bug report, and I'm
> therefore closing it.

All of these keys should be self-inserting during
completion: SPC, ?, C-j.  (Not just SPC and ?.)

It's long past time to do this.  There's no good
reason not to do it.

If you want, add an option for a list of keys to
bind to word completion.

[I do that in Icicles, to give users who still
want word completion an alternative to SPC (and
an easy way to get back SPC if they really want
that to word-complete).  By default, option
`icicle-word-completion-keys' is the singleton
list with key `M-SPC'.]

Or just bind `M-SPC' to `minibuffer-complete-word'
by default.